// Where the database is kept. Only used by Lookup.ServiceImpl to retrieve info
// from the data base and send it to the client.
// Author: ???
unit Database;

interface

uses
  System.SysUtils, System.Classes, Data.DB, MemDS, DBAccess, Uni, UniProvider,
  PostgreSQLUniProvider, System.Variants, System.Generics.Collections, System.IniFiles,
  Common.Logging, Vcl.Forms, MySQLUniProvider;

type
  TFDatabaseModule = class(TDataModule)
    ucKG: TUniConnection;
    UniQuery1: TUniQuery;
    MySQLUniProvider1: TMySQLUniProvider;
    UniQuery2: TUniQuery;
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    class procedure ExecSQL(const SQL: string);
  end;

var
  FDatabaseModule: TFDatabaseModule;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

procedure TFDatabaseModule.DataModuleCreate(Sender: TObject);
// Sets the database connection to the ini file IP
// TODO: clean up unnecessary reads from the ini file
var
  IniFile: TIniFile;
  iniStr: string;
begin
  IniFile := TIniFile.Create( ChangeFileExt(Application.ExeName, '.ini') );
  try
    iniStr := IniFile.ReadString( 'Database', 'Server', '' );
    if iniStr.IsEmpty then
      Logger.Log( 1, 'iniFile: ' + ChangeFileExt(Application.ExeName, '.ini') +
                  ' Database->Server: Entry not found' )
    else
    begin
      Logger.Log( 1, 'iniFile: ' + ChangeFileExt(Application.ExeName, '.ini') +
                  ' Database->Server: ' + iniStr );
      ucKG.Server := iniStr;
    end;

    iniStr := IniFile.ReadString( 'Twilio', 'AccountSID', '' );
    if iniStr.IsEmpty then
      Logger.Log( 1, 'iniFile: ' + ChangeFileExt(Application.ExeName, '.ini') +
                  ' Twilio->AccountSID: Entry not found' )
    else
    begin
      Logger.Log( 1, 'iniFile: ' + ChangeFileExt(Application.ExeName, '.ini') +
                  ' Twilio->AccountSID: ' + iniStr );
      //accountSID := iniStr;
    end;

    iniStr := IniFile.ReadString( 'Twilio', 'AuthHeader', '' );
    if iniStr.IsEmpty then
      Logger.Log( 1, 'iniFile: ' + ChangeFileExt(Application.ExeName, '.ini') +
                  ' Twilio->AuthHeader: Entry not found' )
    else
    begin
      Logger.Log( 1, 'iniFile: ' + ChangeFileExt(Application.ExeName, '.ini') +
                  ' Twilio->AuthHeader: ' + iniStr );
      //authHeader := iniStr;
    end;
    Logger.Log(1, '');
  finally
    IniFile.Free;
  end;
end;

class procedure TFDatabaseModule.ExecSQL(const SQL: string);
var
  DB: TFDatabaseModule;
begin
  DB := TFDatabaseModule.Create(nil);
  try
    DB.UniQuery1.SQL.Text := SQL;
    DB.UniQuery1.ExecSQL;
  finally
    DB.Free;
  end;
end;

end.
